//canvas variables
let canvas;
let context;
let backgroundColor = "#FFFFFF";

let lastDirection = "right";
let snakeDirection;

//snake variables
//TODO: create a snake object variable (1)
//TODO: delete x and y variables to add to object (2)
let snakePosX = 150;
let snakePosY = 150;
let snakeColor = "green";
let snakeWidth = 10;
let snakeHeight = 10;

//food variables
let foodPosX;
let foodPosY;
let foodColor = "red";
let foodWidth = 10;
let foodHeight = 10;	

//time variables
let interval = 50;
let step;

//TODO: add a variable to keep score (7)

//key bindings
let upKey = 119; //W
let downKey = 115; //A
let leftKey = 97; //S
let rightKey = 100; //D


function initial() {
	//set up canvas
	canvas = document.getElementById('canvas');
	context = canvas.getContext('2d');

	//initialize food and snake objects
	newFood();

	//TODO: give the snake object initial x and y values (3)

	//set interval
  	step = setInterval("draw()", interval);

	//initialize key press event listener
  	document.addEventListener("keypress", keyPress, false);
}

function draw() {
	//draw canvas
	context.fillStyle = backgroundColor;
	context.fillRect(0, 0, canvas.width, canvas.height);

	//move snake
	//TODO: add function call to check if snake ate the food (10)
  	animateSnake();

  	//draw snake
  	context.fillStyle = snakeColor;
	context.fillRect(snakePosX, snakePosY, snakeWidth, snakeHeight);

	//draw food
	context.fillStyle = foodColor;
	context.fillRect(foodPosX, foodPosY, foodWidth, foodHeight);

	//draw score
	//TODO: use score variable to draw updated score (8)
	context.fillStyle = "black";
	context.fillText("Score: " + "0", canvas.width - 50, 20);

	//TODO: add function call to check if snake hit a wall (6)
}


function animateSnake() {
	//TODO: update method to use snake object variables instead 
	//of position variables (4)

	if(snakeDirection === "up") {
	    snakePosY -= snakeHeight;
	    lastDirection = "up";
	}
	else if(snakeDirection === "down") {
	    snakePosY += snakeHeight;
	    lastDirection = "down";
	}
	else if(snakeDirection === "right") {
	    snakePosX += snakeWidth;
	    lastDirection = "right";
	}
	else if(snakeDirection === "left") {
	    snakePosX -= snakeWidth;
	    lastDirection = "left";
	}
}

function newFood() {
	//place food at random place on canvas
	foodPosX = Math.floor(Math.random() * (canvas.width - foodWidth));
	foodPosY = Math.floor(Math.random() * (canvas.height - foodHeight));
}

function intersection() {
	//TODO: write conditional to check if snake ate food and update score (9)
}

function checkWalls() {
	//TODO: write conditional to check if snake hit wall (5)
}

function keyPress(evt) {
	//check if key is pressed and update direction
  if (evt.keyCode == upKey && lastDirection != "down") {
      snakeDirection = "up";
  }
  else if (evt.keyCode == downKey && lastDirection != "up") {
      snakeDirection = "down";
  }
  else if (evt.keyCode == leftKey && lastDirection != "right" ) {
      snakeDirection = "left";
  }
  else if (evt.keyCode == rightKey && lastDirection != "left") {
      snakeDirection = "right";
  }
}